# coding: utf-8

"""
    Fenrir Api

    # Introduction  The Fenrir Cloud API allows you to interact with Fenrir Cloud  and manage Applications, Deployments, and other resources  using conventional HTTP requests.    ## Authentication  The Fenrir Cloud API uses API keys for the authentication.  You can create new API keys in your Fenrir Cloud dashboard.  Your bearer API key must be set in the \"Authorization\" header, for example:  ```bash curl https://api.fenrircloud.com/1.0/api/applications \\    -H \"Accept: application/json\" \\    -H \"Authorization: Bearer FENRIR_API_KEY\" ```  ## Responses  When a request is successful, a response body will typically contain a JSON object.  For DELETE requests, a response with successful HTTP 204 NO_CONTENT status and a simple status will be returned.  For other request, a JSON object will contain a requested object. If list of objects is requested, an array of them will be returned instead.   ### Example Response (Single Object)  ```json {   \"application\": {     \"name\": \"my-app\",     ...   } } ```  ### Example Response (Multiple Objects)  ```json {   \"applications\":      [         {           \"name\": \"my-app\",           ...         },         {           \"name\": \"another-app\",           ...         }     ] } ```  ## Error Handling  Depending on the issue, a *4XX* status code will be returned.  A body will contain a JSON object with the details of the message.  Inside a JSON object, an error message will be included.   For 400 Bad Request errors caused by validation issues, additional `errors` key will be set. That key will contain a list of   ### Example Error Response  ```json {   \"message\": \"Invalid Request\",   \"errors\": [     {       \"field\": \"configuration.name\",       \"error\": \"must not contain special characters\"]     },     ...   ] } ```  

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from fenrir_api.models.application import Application

class TestApplication(unittest.TestCase):
    """Application unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional) -> Application:
        """Test Application
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `Application`
        """
        model = Application()
        if include_optional:
            return Application(
                configuration = fenrir_api.models.application_configuration.ApplicationConfiguration(
                    application_uuid = 'df345e3497b14f2ca1ecd8c160131d7a', 
                    created = '2024-01-22T19:28:42Z', 
                    max_instances = 5, 
                    min_instances = 1, 
                    ports = [
                        fenrir_api.models.port_configuration.PortConfiguration(
                            port_number = 27015, 
                            protocol = 'udp', )
                        ], 
                    updated = '2024-01-22T19:28:42Z', 
                    uuid = '4a56d881916b48ac96e49e448f92f829', ),
                created = '2024-01-22T19:28:42Z',
                name = 'my-application',
                updated = '2024-01-22T19:28:42Z',
                uuid = '262e7483484e40078abfdee18a89e7d2'
            )
        else:
            return Application(
                configuration = fenrir_api.models.application_configuration.ApplicationConfiguration(
                    application_uuid = 'df345e3497b14f2ca1ecd8c160131d7a', 
                    created = '2024-01-22T19:28:42Z', 
                    max_instances = 5, 
                    min_instances = 1, 
                    ports = [
                        fenrir_api.models.port_configuration.PortConfiguration(
                            port_number = 27015, 
                            protocol = 'udp', )
                        ], 
                    updated = '2024-01-22T19:28:42Z', 
                    uuid = '4a56d881916b48ac96e49e448f92f829', ),
                name = 'my-application',
        )
        """

    def testApplication(self):
        """Test Application"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
